-- errsav.exm
-- Matt Lewis
-- matthewwalkerlewis@yahoo.com
-- This is a demo to show how you could save the state of all program
-- variables in case of a crash.  It can be used as is by simply including
-- it into your application and running it with my modified interpreter.


include machine.e
include crash.em
include variable.em
include database.e

procedure error_dump()
    object ok
    sequence symtab
	puts(1,"***********************************************************\n")
	puts(1,"Alert!  Program has crashed.\n")
    puts(1,"Variables are being written to error.edb (table \"vars\")\n")
    
    -- open or create the db and table
    ok = db_open("error.edb", DB_LOCK_NO)
    if ok != DB_OK then
        ok = db_create("error.edb", DB_LOCK_NO)
        if ok != DB_OK then
            puts(1,"Couldn't open error.edb\n")
        end if
    end if
    
    ok = db_table_list()
    if find("vars", ok) then
        db_delete_table( "vars" )
    end if
    
    ok = db_create_table( "vars" )
    ok = db_select_table( "vars" )
    
    symtab = dump_variables()

    -- write the variables to the db
    for i = 1 to length( symtab ) do
        ok = db_insert( symtab[i], read_variable( symtab[i][4] ))
        puts(1,".")
    end for
    
    db_close()
    printf(1,"\n%d Variables successfully saved to error.edb\n", length(symtab))
	puts(1,"***********************************************************\n")
end procedure

crash_routine( routine_id("error_dump") )
