/*****************************************************************************/
/*                    (c) Copyright 2003 Matt Lewis                          */
/*****************************************************************************/
/*                                                                           */
/*                  GLOBAL CONFLICT RESOLUTION ROUTINES                      */
/*                                                                           */
/*****************************************************************************/


/******************/
/* Included files */
/******************/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#include "include.h"
#include "global.h"
#include "execute.h"
#include "symtab.h"
#include "reswords.h"

/**********************/
/* Declared functions */
/**********************/

char *EMalloc(unsigned long);
char *ERealloc(unsigned char *orig, unsigned long newsize);

/*******************/
/* Local variables */
/*******************/
include_ptr Include_List[1000];

/**********************/
/* Imported variables */
/**********************/
extern symtab_ptr buckets[];
extern int current_file_no;
extern char *file_name[];

/*********************/
/* Defined functions */
/*********************/

// This function records include files by adding to the
// linked list for file number fn.
void add_include( int fn, int incfn )
{
    include_ptr il;
    long i;

        if (max_include_list == 0 ){
                max_include_list = 1000;
/*                *Include_List = (include_ptr) EMalloc(  (max_include_list+1) * sizeof(include_ptr) );
                for( i = 0; i <= max_include_list; i++)
                        Include_List[i] = 0;
                printf("Include_List %d  max_include_list %d\n",(long) &Include_List, max_include_list);
*/
        }

    // make sure Inlude_List is big enough
    if (incfn >= max_include_list) {
        // need to grow the array...
        max_include_list += 1;
        printf("Reallocing: %d\n",(max_include_list+1)*sizeof(include_ptr));
        *Include_List = (include_ptr) ERealloc(
            (char *)Include_List, (max_include_list+1) * sizeof(include_ptr));
        printf("Include_List %d  max_include_list %d\n",(long) &Include_List, max_include_list);
        for( i = max_include_list - 9; i <= max_include_list; i++)
            Include_List[i] = 0;
    }

    // allocate a new include_list item
    il = (include_ptr) EMalloc( 8 );

    // store the file number of the include file
    il->file_number = incfn;

    // the first file listed becomes the second...
    if ( Include_List[fn] != (include_ptr)0 )
        il->next_file = (void *)Include_List[fn];
    else
        il->next_file = (void *) 0;
        
    // update the parent linked list
    Include_List[fn] = il;
}


// determines whether source_file was directly or indirectly
// included from this_file, or if this_file == source_file
int in_include_tree( int this_file, int source_file ){
    include_ptr il;

//printf("this: %d source: %d ", this_file, source_file);

    // in case they're the same
    if (this_file == source_file){
        return 1;
    }



    // get the linked list for this_file
    il = (include_ptr) Include_List[this_file];

    // no includes...
    if ( il == (include_ptr) 0 ) return 0;

    // need to check for the first one...
    if (il->file_number == source_file){
        return 1;
    }

    // then loop through the list
    for( il; il != (include_ptr) 0; il = (include_ptr) il->next_file ){

        if (il->file_number == source_file){
            return 1;
        }
        else
            // check that file's include tree recursively
            // since the max include depth is 30, this
            // shouldn't be a problem
            if (in_include_tree( il->file_number, source_file ) ){
                return 1;
            }
    }

    // couldn't find it anywhere...
    return 0;
}
