-- variable.em
include machine.e

global constant
M_VARIABLE_ID = 66,
M_READ_VARIABLE = 67,
M_WRITE_VARIABLE = 68,
M_DUMP_VARIABLE = 69,
M_CREATE_VARIABLE = 70

global constant
TYPE_INTEGER = 1,
TYPE_ATOM = 4,
TYPE_SEQUENCE = 8,
TYPE_OBJECT = 16

global function variable_id( sequence name )
    return machine_func( M_VARIABLE_ID, name )
end function

global function read_variable( integer variable_id )
    return machine_func( M_READ_VARIABLE, variable_id )
end function

global procedure write_variable( integer variable_id, object val )
    machine_proc( M_WRITE_VARIABLE, {variable_id,val}) 
end procedure

global function dump_variables()
    return machine_func( M_DUMP_VARIABLE, {} )
end function

global function create_variable( sequence name, integer type_, object val )
    return machine_func( M_CREATE_VARIABLE, {name,type_,val} )
end function
